
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>repository: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">crudapp/internal/pkg/link/repository/repo_postgres_link.go (97.6%)</option>
				
				<option value="file1">crudapp/internal/pkg/paste/repository/repo_postgres_paste.go (96.8%)</option>
				
				<option value="file2">crudapp/internal/pkg/session/repository/repo_postgres_session.go (61.1%)</option>
				
				<option value="file3">crudapp/internal/pkg/user/repository/repo_postgres_user.go (81.1%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package repository

import (
        "crudapp/internal/pkg/models"
        "database/sql"
)

// Postgres repository for links
type PostgresLinkRepo struct {
        DB *sql.DB
}

// Init repo
func NewPostgresLinkRepo(db *sql.DB) *PostgresLinkRepo <span class="cov0" title="0">{
        return &amp;PostgresLinkRepo{DB: db}
}</span>

// Get link by token
func (repo *PostgresLinkRepo) GetByToken(token string) (*models.Link, error) <span class="cov8" title="1">{
        link := &amp;models.Link{}

        err := repo.DB.QueryRow(`SELECT id, token, long_link, clicks, user_id FROM link WHERE token=$1`, token).
                Scan(&amp;link.ID, &amp;link.Token, &amp;link.LongLink, &amp;link.ClicksCount, &amp;link.UserID)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoLink
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return link, nil</span>
}

// Get link by long link
func (repo *PostgresLinkRepo) GetByLongLinkAndUserID(longLink string, userID int) (*models.Link, error) <span class="cov8" title="1">{
        link := &amp;models.Link{}

        err := repo.DB.QueryRow(`SELECT id, token, long_link, clicks, user_id FROM link WHERE long_link=$1 and user_id=$2`, longLink, userID).
                Scan(&amp;link.ID, &amp;link.Token, &amp;link.LongLink, &amp;link.ClicksCount, &amp;link.UserID)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoLink
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return link, nil</span>
}

// Get links slice by userID
func (repo *PostgresLinkRepo) GetByUserID(userID int) ([]*models.Link, error) <span class="cov8" title="1">{
        links := make([]*models.Link, 0)

        rows, err := repo.DB.Query(`SELECT id, token, long_link, clicks, user_id FROM link WHERE user_id=$1`, userID)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoLink
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">defer rows.Close()

        for rows.Next() </span><span class="cov8" title="1">{
                link := &amp;models.Link{}
                err := rows.Scan(&amp;link.ID, &amp;link.Token, &amp;link.LongLink, &amp;link.ClicksCount, &amp;link.UserID)
                if err != nil </span><span class="cov8" title="1">{
                        return nil, err
                }</span>

                <span class="cov8" title="1">links = append(links, link)</span>
        }
        <span class="cov8" title="1">return links, nil</span>
}

func (repo *PostgresLinkRepo) GetCount() (int, error) <span class="cov8" title="1">{
        var id = 0
        err := repo.DB.QueryRow(`SELECT COUNT(*) FROM link`).Scan(&amp;id)
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>
        <span class="cov8" title="1">return id, nil</span>
}

// Create new link from long link and userID, returned link model
func (repo *PostgresLinkRepo) Create(l *models.Link) (int64, error) <span class="cov8" title="1">{
        _, err := repo.DB.Exec(
                `INSERT INTO link ("token", "long_link", "clicks", "user_id") VALUES ($1, $2, $3, $4)`,
                l.Token,
                l.LongLink,
                0,
                l.UserID,
        )
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return 1, nil</span>
}

// Increment clicks counter for link by token
func (repo *PostgresLinkRepo) Click(token string) (int64, error) <span class="cov8" title="1">{
        _, err := repo.DB.Exec(`UPDATE link SET clicks = clicks + 1 WHERE token = $1;`, token)
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>
        <span class="cov8" title="1">return 1, nil</span>
}</pre>
		
		<pre class="file" id="file1" style="display: none">package repository

import (
        "crudapp/internal/pkg/models"
        "database/sql"
)

type PostgresPasteRepo struct {
        DB *sql.DB
}

func NewPostgresPasteRepo(db *sql.DB) *PostgresPasteRepo <span class="cov0" title="0">{
        return &amp;PostgresPasteRepo{
                DB: db,
        }
}</span>

func (repo *PostgresPasteRepo) GetPastesCount() (int, error) <span class="cov8" title="1">{
        var id int
        err := repo.DB.QueryRow(`SELECT COUNT(*) FROM paste`).Scan(&amp;id)
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return id, nil</span>
}


func (repo *PostgresPasteRepo) Create(p *models.Paste) (int64, error)<span class="cov8" title="1">{
        result, err := repo.DB.Exec(`INSERT INTO paste (user_id, token, name, text) VALUES ($1, $2, $3, $4)`,
                p.UserID, p.Token, p.Name, p.Text)

        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return result.RowsAffected()</span>
}

func (repo *PostgresPasteRepo) GetByUserID(userID int) ([]models.Paste, error) <span class="cov8" title="1">{
        pastes := make([]models.Paste, 0)

        rows, err := repo.DB.Query(`SELECT id, user_id, token, name, text FROM paste WHERE user_id=$1`, userID)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoPaste
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">defer rows.Close()

        for rows.Next() </span><span class="cov8" title="1">{
                paste := models.Paste{}
                err := rows.Scan(&amp;paste.ID, &amp;paste.UserID, &amp;paste.Token, &amp;paste.Name, &amp;paste.Text)
                if err != nil </span><span class="cov8" title="1">{
                        return nil, err
                }</span>

                <span class="cov8" title="1">pastes = append(pastes, paste)</span>
        }

        <span class="cov8" title="1">return pastes, nil</span>
}

func (repo *PostgresPasteRepo) GetByToken(token string) (*models.Paste, error) <span class="cov8" title="1">{
        paste := &amp;models.Paste{}

        err := repo.DB.QueryRow(`SELECT id, user_id, token, name, text FROM paste WHERE token=$1`, token).
                Scan(&amp;paste.ID, &amp;paste.UserID, &amp;paste.Token, &amp;paste.Name, &amp;paste.Text)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoPaste
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return paste, nil</span>
}</pre>
		
		<pre class="file" id="file2" style="display: none">package repository

import (
        "crudapp/internal/pkg/models"
        "database/sql"
        "time"
)


type PostgresSessionRepo struct {
        DB *sql.DB
}


func NewPostgresSessionRepo(db *sql.DB) *PostgresSessionRepo <span class="cov0" title="0">{
        return &amp;PostgresSessionRepo{DB: db}
}</span>


func (repo *PostgresSessionRepo) CreateSession(s *models.Session) (int64, error) <span class="cov8" title="1">{
        result, err := repo.DB.Exec(
                `INSERT INTO session ("user_id", "token", "created", "expires") VALUES ($1, $2, $3, $4)`,
                s.UserID,
                s.Token,
                s.Created,
                s.Expires,
        )

        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return result.RowsAffected()</span>
}


func (repo *PostgresSessionRepo) CheckSession(token string) (*models.Session, error) <span class="cov8" title="1">{
        session := &amp;models.Session{}

        err := repo.DB.QueryRow(`SELECT id, user_id, token, created, expires FROM session WHERE token=$1`, token).
                Scan(&amp;session.ID, &amp;session.UserID, &amp;session.Token, &amp;session.Created, &amp;session.Expires)

        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">if session.Expires.Before(time.Now()) </span><span class="cov0" title="0">{
                return nil, models.ErrExpiredSession
        }</span>

        <span class="cov8" title="1">if token != session.Token </span><span class="cov0" title="0">{
                return nil, models.ErrNoSession
        }</span>

        <span class="cov8" title="1">return session, nil</span>
}

func (repo *PostgresSessionRepo) CloseSession(userID int) error <span class="cov0" title="0">{
        _, err := repo.DB.Exec(`DELETE FROM session WHERE user_id=$1`, userID)
        if err != nil </span><span class="cov0" title="0">{
                return err
        }</span>

        <span class="cov0" title="0">return nil</span>
}
</pre>
		
		<pre class="file" id="file3" style="display: none">package repository

import (
        "crudapp/internal/pkg/models"
        "database/sql"
)


type PostgresUserRepo struct {
        DB *sql.DB
}


func NewPostgresUserRepo(db *sql.DB) *PostgresUserRepo <span class="cov0" title="0">{
        return &amp;PostgresUserRepo{DB: db}
}</span>

// Метод поиска в репозитории пользователя по переданному логину
// Возвращает пользователя, ошибку если произошла
func (repo *PostgresUserRepo) GetByID(id int) (*models.User, error) <span class="cov8" title="1">{
        user := &amp;models.User{}

        err := repo.DB.
                QueryRow(`SELECT id, login, password FROM users WHERE id = $1`, id).
                Scan(&amp;user.ID, &amp;user.Login, &amp;user.Password)

        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return user, nil</span>
}

func (repo *PostgresUserRepo) GetByLogin(login string) (*models.User, error) <span class="cov8" title="1">{
        user := &amp;models.User{}

        err := repo.DB.
                QueryRow(`SELECT id, login, password FROM users WHERE login = $1`, login).
                Scan(&amp;user.ID, &amp;user.Login, &amp;user.Password)

        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, models.ErrNoUser
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>
        <span class="cov8" title="1">return user, nil</span>
}

func (repo *PostgresUserRepo) GetList(limit, offset int) ([]*models.User, error) <span class="cov8" title="1">{
        users := make([]*models.User, 0, limit)

        rows, err := repo.DB.Query("SELECT id, login, password FROM users OFFSET $1 LIMIT $2", offset, limit)
        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>
        <span class="cov8" title="1">defer rows.Close()

        for rows.Next() </span><span class="cov8" title="1">{
                user := &amp;models.User{}
                err := rows.Scan(&amp;user.ID, &amp;user.Login, &amp;user.Password)
                if err != nil </span><span class="cov8" title="1">{
                        return nil, err
                }</span>
                <span class="cov8" title="1">users = append(users, user)</span>
        }
        <span class="cov8" title="1">return users, nil</span>
}

func (repo *PostgresUserRepo) Create(u *models.User) (int64, error) <span class="cov8" title="1">{
        result, err := repo.DB.Exec(
                `INSERT INTO users ("login", "password") VALUES ($1, $2)`,
                u.Login,
                u.Password,
        )

        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">if ra, _ := result.RowsAffected(); ra == 0 </span><span class="cov8" title="1">{
                return 0, nil
        }</span>

        <span class="cov8" title="1">return result.LastInsertId()</span>
}

// Метод проверки пароля пользователя
// Если пользователь найден и прошел проверку пароля, отправляем его
func (repo *PostgresUserRepo) Authorize(login, password string) (*models.User, error) <span class="cov0" title="0">{
        u, err := repo.GetByLogin(login)
        if err != nil </span><span class="cov0" title="0">{
                return nil, models.ErrNoUser
        }</span>

        <span class="cov0" title="0">if models.CheckPass(u.Password, password) </span><span class="cov0" title="0">{
                return u, nil
        }</span>

        <span class="cov0" title="0">return nil, err</span>
}</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
